function showTree(tree)

    wmCount = length(tree.weakModels);
    
    s = 0.5;
    
    
    hDistEnd = 2;
    hDistIni = hDistEnd/((2*s)*(0.5)^((tree.depth-1)));
    vDist = 2*hDistEnd;
    
    hPos = zeros(1,wmCount);
    
    plot(0,0,'o','MarkerSize',10);
    
    hold on
    
    %plot internal nodes
    for i=2:wmCount
        if (tree.weakModels{i}.classifierID~=0)
            %there is some classifier in this node
            level = floor(log2(i));
            parent = floor(i/2);
            
            
            LorR = double(floor(i/2) < i/2); %if 0 -> left, if 1 -> right
            
            hPos(i) = LorR*(hPos(parent)-s*(0.5)^level*hDistIni) + (1-LorR)*(hPos(parent)+s*(0.5)^level*hDistIni);
            
            plot(hPos(i),vDist*level,'o','MarkerSize',10);
            plot([hPos(i) hPos(parent)],[vDist*level vDist*(level-1)]);
            
            vals = tree.weakModels{i}.classDist/sum(tree.weakModels{i}.classDist);
            
            plotLocalHist(hPos(i),vDist*level,[hDistEnd vDist],vals);
            text(hPos(i),vDist*(level-0.5),['Total: ' num2str(sum(tree.weakModels{i}.classDist))]);
            
        end
    end
    
    level = tree.depth-1;
    %plot leaf nodes (check the classified pa
    for i=1:size(tree.leafdist)
        
        idx = i+wmCount;
        parent = floor(idx/2);
        
        %some samples reached the leaf
        if sum(tree.leaftotal(i))>0 
        
            LorR = double(floor(idx/2) < idx/2);
            hPosCur = LorR*(hPos(parent)-s*(0.5)^level*hDistIni) + (1-LorR)*(hPos(parent)+s*(0.5)^level*hDistIni);
        
            plot(hPosCur,vDist*level,'o','MarkerSize',10);
            plot([hPosCur hPos(parent)],[vDist*level vDist*(level-1)]);
        
            vals = tree.leafdist(i,:);
            plotLocalHist(hPosCur,vDist*level,[hDistEnd vDist],vals);
        
            text(hPosCur,vDist*(level-0.5),['Total: ' num2str(tree.leaftotal(i))]);
            
        end
            
    end
    
    axis equal

end

